#include <stdio.h>
#include <stdbool.h>
#include "data_ora.h"
#include "dati_meteo.h"
#include "archivio.h"
#include "statistiche.h"

// == funzioni ==========================================

void stampa_menu(void);
char leggi_scelta(void);

// ======================================================

int main(void) {
	char s;
	struct archivio a;
	a.dati_registrati = 0;
	
	do{
		stampa_menu();
		s = leggi_scelta();
		
		switch(s) {
			case 'r':
				a = registra(a, leggi_dati_meteo());
				break;
			case 's':
				stampa_statistiche(calcola(a));
				break;
			case 'h':
				stampa_menu();
				break;
			case 'e':
				return; // esce dal programma
			default:
				printf("Scelta non disponibile.\n");
				stampa_menu();
				break;
		}
	} while(true);
	return 0;
}

/*
 * Funzione che stampa il menu del programma.
 */
void stampa_menu( void ){
	printf( "-----------------------------------------------------\n" );
	printf( "Programma per la registrazione di dati meteorologici.\n" );
	printf( "Operazioni disponibili:\n" );
	printf( "	r: registra un nuovo dato meteorologico\n" );
	printf( "	s: calcola statistiche\n" );
	printf( "	h: stampa questo menu\n" );
	printf( "	e: esci\n\n" );
}

/*
 * Funzione che richiede all'utente un carattere e lo restituisce
 */
char leggi_scelta(void) {
	char c;
	printf("Quale operazione vuoi eseguire (r/s/h/e): ");
	scanf(" %c", &c);
	return c;
}
