#include <stdio.h>
#include <stdbool.h>
#include "data_ora.h"
#include "dati_meteo.h"
#include "archivio.h"
#include "statistiche.h"


/*
 * Funzione che calcola statistiche
 */
struct statistiche calcola (struct archivio a) {
	int i;
	
	if (a.dati_registrati == 0)
		return (struct statistiche) {.0, .0, .0, .0, .0, .0, .0, .0, .0, .0, .0, .0};
	struct statistiche s = (struct statistiche) {
		a.dati[0].temperatura,
		a.dati[0].temperatura,
		a.dati[0].temperatura,
		a.dati[0].pressione,
		a.dati[0].pressione,
		a.dati[0].pressione,
		a.dati[0].umidita,
		a.dati[0].umidita,
		a.dati[0].umidita,
		a.dati[0].pioggia,
		a.dati[0].pioggia,
		a.dati[0].pioggia,};
	for (i = 1; i < a.dati_registrati; i++) {
		
		if (a.dati[i].temperatura < s.temperatura_minima)
			s.temperatura_minima = a.dati[i].temperatura;
		if (a.dati[i].temperatura > s.temperatura_massima)
			s.temperatura_massima = a.dati[i].temperatura;
		s.temperatura_media += a.dati[i].temperatura;
		
		if (a.dati[i].pressione < s.pressione_minima)
			s.pressione_minima = a.dati[i].pressione;
		if (a.dati[i].pressione > s.pressione_massima)
			s.pressione_massima = a.dati[i].pressione;
		s.pressione_media += a.dati[i].pressione;
		
		if (a.dati[i].umidita < s.umidita_minima)
			s.umidita_minima = a.dati[i].umidita;
		if (a.dati[i].umidita > s.umidita_massima)
			s.umidita_massima = a.dati[i].umidita;
		s.umidita_media += a.dati[i].umidita;
		
		if (a.dati[i].pioggia < s.pioggia_minima)
			s.pioggia_minima = a.dati[i].pioggia;
		if (a.dati[i].pioggia > s.pioggia_massima)
			s.pioggia_massima = a.dati[i].pioggia;
		s.pioggia_media += a.dati[i].pioggia;
	}
	
	s.temperatura_media = s.temperatura_media / a.dati_registrati;
	s.pressione_media = s.pressione_media / a.dati_registrati;
	s.umidita_media = s.umidita_media / a.dati_registrati;
	s.pioggia_media = s.pioggia_media / a.dati_registrati;
	
	return s;
}

/*
 * Funzione che stampa statistiche
 */
void stampa_statistiche(struct statistiche st) {
	printf("Temperatura minima: %f\n", st.temperatura_minima);
	printf("Temperatura massima: %f\n", st.temperatura_massima);
	printf("Temperatura media: %f\n", st.temperatura_media);
	printf("Pressione minima: %f\n", st.pressione_minima);
	printf("Pressione massima: %f\n", st.pressione_massima);
	printf("Pressione media: %f\n", st.pressione_media);
	printf("Umidita' minima: %f\n", st.umidita_minima);
	printf("Umidita' massima: %f\n", st.umidita_massima);
	printf("Umidita' media: %f\n", st.umidita_media);
	printf("Pioggia minima: %f\n", st.pioggia_minima);
	printf("Pioggia massima: %f\n", st.pioggia_massima);
	printf("Pioggia media: %f\n\n", st.pioggia_media);
}
