#include <stdio.h>
#include <stdbool.h>
#include "data.h"
#include "esame.h"
#include "libretto.h"


/*
 * Funzione che stampa la lista degli esami contenuti nel libretto l
 */
void stampa_esami(struct libretto l) {
	int i;
	for (i = 0; i < l.numero_esami; i++) {
		printf("Titolo corso: %c%c%c\n", 
				l.esami[i].nome_corso[0], 
				l.esami[i].nome_corso[1], 
				l.esami[i].nome_corso[2]);
		printf("Docente: %c%c\n", 
				l.esami[i].nome_docente[0], 
				l.esami[i].nome_docente[1]);
		printf("Data esame: %.2i/%.2i/%.4i\n", 
				l.esami[i].data_esame.giorno,
				l.esami[i].data_esame.mese,
				l.esami[i].data_esame.anno);
		printf("Voto: %i%s\n\n", l.esami[i].voto, l.esami[i].lode ? "L" : "");
	}
}


/*
 * Funzione che calcola la media dei voti registrati
 */
float media (struct libretto l) {
	int i;
	float m = 0;
	
	if (l.numero_esami == 0) {
		printf("Non ci sono esami registrati\n\n");
		return 0;
	}
	
	for (i = 0; i < l.numero_esami; i++) {
		m += l.esami[i].voto;
	}
	return m / l.numero_esami;
}
 

/*
 * Funzione che calcola il numero di lodi registrate
 */
int num_lodi (struct libretto l) {
	int i;
	int n = 0;
	
	for (i = 0; i < l.numero_esami; i++) {
		if (l.esami[i].lode == true) {
			n++;
		}
	}
	return n;
}


/*
 * Funzione che registra un nuovo esame nel libretto
 */
struct libretto registra_esame(struct libretto l, struct esame e) {
	if (l.numero_esami < 20) {
		l.esami[l.numero_esami] = e;
		l.numero_esami++;
	} else {
		printf("Tutti gli esami sono gia' stati registrati.\n\n");
	}
	return l;
}
