#include <stdio.h>
#include <stdbool.h>
#include "data.h"
#include "esame.h"
#include "libretto.h"

// == funzioni ==========================================

void stampa_menu(void);
char leggi_scelta(void);

// ======================================================


int main(void) {
	char s, b;
	struct libretto l;
	struct esame e;
	int i;
	
	l.numero_esami = 0;
	
	do{
		stampa_menu();
		s = leggi_scelta();
		
		switch(s) {
			case 's':
				stampa_esami(l);
				break;
			case 'm':
				printf("La media dei voti registrati e': %2f\n\n", media(l));
				break;
			case 'l':
				printf("Il numero di lodi registrate e': %i\n\n", num_lodi(l));
				break;
			case 'r':
				printf("Nome corso (tre caratteri): ");
				for (i = 0; i < 3; i++)
					scanf(" %c", &e.nome_corso[i]);
				printf("Nome docente (iniziali): ");
				for (i = 0; i < 2; i++)
					scanf(" %c", &e.nome_docente[i]);
				printf( "Data esame: " );
				scanf("%i/%i/%i", 
						&e.data_esame.giorno, 
						&e.data_esame.mese, 
						&e.data_esame.anno);
				printf("Voto: ");
				scanf("%i", &e.voto);
				e.lode = false;
				if (e.voto == 30) {
					printf("Lode (s/n): ");
					scanf(" %c", &b);
					if (b == 's')
						e.lode = true;						
				}
				l = registra_esame(l, e);
				break;
			case 'h':
				stampa_menu();
				break;
			case 'e':
				break;
			default:
				printf("Scelta non disponibile.\n");
				stampa_menu();
				break;
		}
	} while(s != 'e');
	return 0;
}


/*
 * Funzione che stampa il menu del programma.
 */
void stampa_menu (void) {
	printf("--------------------------------------------------------\n");
	printf("Programma per la gestione di un libretto universitario.\n");
	printf("Operazioni disponibili:\n");
	printf("  s: stampa la lista degli esami registrati\n");
	printf("  m: calcola la media degli esami registrati\n");
	printf("  l: calcola il numero di lodi registrate\n");
	printf("  r: registra un nuovo esame\n");
	printf("  h: stampa questo menu\n");
	printf("  e: esci\n\n");
}


/*
 * Funzione che richiede all'utente un carattere e lo restituisce
 */
char leggi_scelta(void) {
	char c;
	printf("Quale operazione vuoi eseguire (s/m/l/r/h/e): ");
	scanf(" %c", &c);
	return c;
}
